package fr.mael.jiwigo.transverse.util.spring;

import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;

import fr.mael.jiwigo.service.CategoryService;
import fr.mael.jiwigo.service.CommentService;
import fr.mael.jiwigo.service.ImageService;
import fr.mael.jiwigo.service.TagService;
import fr.mael.jiwigo.transverse.session.SessionManager;

public class SpringUtils {

    /**
     * Id of the image service bean
     */
    private static String IMAGE_SERVICE = "imageService";
    /**
     * Id of the tag service bean
     */
    private static String TAG_SERVICE = "tagService";
    /**
     * Id of the category service bean
     */
    private static String CATEGORY_SERVICE = "categoryService";
    /**
     * Id of the comment service bean
     */
    private static String COMMENT_SERVICE = "commentService";

    private static String SESSION_MANAGER = "sessionManager";

    /**
     * bean factory
     */
    private static XmlBeanFactory factory = new XmlBeanFactory(new ClassPathResource("application-context.xml"));

    private SpringUtils() {
    }

    /**
     * @return the image service
     */
    public static ImageService getImageService() {
	return (ImageService) factory.getBean(IMAGE_SERVICE);
    }

    /**
     * @return the tag service
     */
    public static TagService getTagService() {
	return (TagService) factory.getBean(TAG_SERVICE);
    }

    /**
     * @return the comment service
     */
    public static CommentService getCommentService() {
	return (CommentService) factory.getBean(COMMENT_SERVICE);
    }

    /**
     * @return the category service
     */
    public static CategoryService getCategoryService() {
	return (CategoryService) factory.getBean(CATEGORY_SERVICE);
    }

    /**
     * @return the session manager
     */
    public static SessionManager getSessionManager() {
	return (SessionManager) factory.getBean(SESSION_MANAGER);
    }

    //    public static void main(String[] args) {
    //	try {
    //	    SessionManager sessionManager = getSessionManager();
    //	    sessionManager.setLogin("mael");
    //	    sessionManager.setUrl("http://mael.piwigo.com/ws.php");
    //	    sessionManager.setPassword("motdepasse");
    //	} catch (IOException e) {
    //	    // TODO Auto-generated catch block
    //	    e.printStackTrace();
    //	} catch (ProxyAuthenticationException e) {
    //	    // TODO Auto-generated catch block
    //	    e.printStackTrace();
    //	}
    //    }

}
